// ***********************************************************************
// File : 		ex1.C
// Purpose : 	ϥ C30  Peripheral Library ӳW Timer1 & Timer3
//				Timer1 : 200ms  _ CPU @
//				Timer3 : 1ms _ CPU @
// ***********************************************************************

#define __dsPIC30F4011__

#include 	<timer.h>
#include 	<p30F4011.h>
#include	"APP009V2_LCD.h"

#define	FCY			14745600			// Osc. configuration = XT, PLL * 8 and XT = 7.3728 Mhz

#define	LED13		LATDbits.LATD0 
#define	LED14		LATDbits.LATD1 
#define	DIR_LED13	TRISDbits.TRISD0 
#define	DIR_LED14	TRISDbits.TRISD1
#define	INPUT		1
#define	OUTPUT		0	

void	Timer3_Initial( void ) ;
void	Timer1_Initial( void ) ;

struct
	{
		unsigned T3OV : 1 ;
		unsigned :15 ;

	} Flags ;

int	CounterT3 ;

//---------------------------------------------------------------------------
// аѦҦB Configuration bits {ŧi覡
// ԲӪѼƦCаѦ p30F4011.h 
//---------------------------------------------------------------------------
   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //Code protect disabled
	

// ---------------------------------------------------------------------
// ŧi _T3Interrupt( ) for Timer 3 _ . W٥P .gld wqۦP
// аѦ \pic30_tools\support\gld\p30f4011.gld
// ---------------------------------------------------------------------
void _ISR _T3Interrupt(void)
{
	
	Flags.T3OV = 1 ;
	IFS0bits.T3IF = 0 ;
	
}

// ---------------------------------------------------------------------
// ŧi _T1Interrupt( ) for Timer 1 _ . W٥P .gld wqۦP
// аѦ \pic30_tools\support\gld\p30f4011.gld
// ---------------------------------------------------------------------
void __attribute__((__interrupt__)) _T1Interrupt(void)
{

	LED13 = !LED13 ;
	IFS0bits.T1IF = 0 ;
	
}


int _EEDATA(2) EEPROM_Data[10] = { 0,1,2,3,4,5,6,7,8,9 } ;

int	main( void )

{
	int	X123 ;

	Flags.T3OV = 0 ;

	Timer1_Initial( ) ;
	Timer3_Initial( ) ;
	OpenLCD( ) ;
	
	CounterT3 = 0 ;

	DIR_LED13 = OUTPUT ;
	DIR_LED14 = OUTPUT ;

		putrsLCD("EEPROM :        ") ;
		setcurLCD(0,1) ;
		putrsLCD("T1:200ms T3:1ms ") ;

	PSVPAG = 0xff ;
	CORCONbits.PSV = 1 ;

	setcurLCD(13,0) ;
	X123 = EEPROM_Data[2] ;
	puthexLCD( (char)X123) ;
	
 while (1) 
	{
	
		if ( Flags.T3OV )
		{
			CounterT3 +=1 ;

			if ( CounterT3 >= 400 )
			{
				LED14 = ! LED14 ;	
				CounterT3 = 0 ;
			}
				Flags.T3OV = 0 ;
		}
	}

}

void	Timer1_Initial( void )
{
		ConfigIntTimer1( T1_INT_PRIOR_7 & T1_INT_ON ) ;
		OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & T1_PS_1_64 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
					((long)(FCY/ 1000 )* 200 / 64) ) ;
}

void	Timer3_Initial( void )
{

		ConfigIntTimer3( T3_INT_PRIOR_7 & T3_INT_ON ) ;
		OpenTimer3( T3_ON & T3_IDLE_STOP & T3_GATE_OFF & T3_PS_1_1 & T3_SOURCE_INT ,
					((long)(FCY/ 1000 )) -1  ) ;
}


