
; Initialization Code for dsPIC30F4011, Family: motor control, Package: 44-Pin TQFP 44pins

.include "p30F4011.inc"



; Filter Controls used to Generate Code:

; POR Match Filter OFF

; Provisioned Feature Filter OFF

; Masks are Ignored and uses UnMasked Register Writes

.GLOBAL _VisualInitialization

; Feature=fuses - fuses (DCR) configuration

; B15:14=FSCKM1:0 B9:8=FOS1:0 B3:0=FPR3:0
	config __FOSC, 0xC100

; B15=FWDTEN B5:4=FWPSA1:0 B3:0=FWPSB3:0
	config __FWDT, 0x803F

; B15=MCLREN B10=PWMPIN B9=HPOL B8=LPOL

; B7=BOREN B5:4=BORV1:0 B3:0=FPWRT3:0
	config __FBORPOR, 0x87B3

.text

_VisualInitialization:

; Feature=Interrupts - Disable Interrupts during configuration

; clear int flags:

; B15=CN B14=BCL B13=I2C B12=NVM B11=AD B10=U1TX B9=U1RX B8=SPI1

; B7=T3 B6=T2 B5=OC2 B4=IC2 B3=T1 B2=OC1 B1=IC1 B0=INT0
	CLR IFS0

; B15:12=IC6:3 B11=C1 B10=SPI2 B9=U2TX B8=U2RX

; B7=INT2 B6=T5 B5=T4 B4=OC4 B3=OC3 B2=IC8 B1=IC7 B0=INT1
	CLR IFS1

; B12=FLTB B11=FLTA B10=LVD B9=DCI B8=QEI

; B7=PWM B6=C2 B5=INT4 B4=INT3 B3:0=OC8:5
	CLR IFS2
	CLR IEC0
	CLR IEC1
	CLR IEC2

; Feature=Reset - Reset configuration

; B15=TRAPR B14=IOPWR B13=BGST B12=LVDEN B11:8=LVDL3:0

; B7=EXTR B6=SWR B5=SWDTEN B4=WDTO B3=SLEEP B2=IDLE B1=BOR B0=POR
	MOV #0x0003, W0
	MOV W0, RCON

; Feature=DSP - DSP core configuration

; B11=EDT B10:8=DL2:0 B7=SATA B6=SATB B5=SATDW

; B4=ACCSAT B3=IPL3 B2=PSV B1=RND B0=IF
	MOV #0x0020, W0
	MOV W0, CORCON

; Feature=NVM - NVM configuration - not implemented

; Feature=Oscillator - Oscillator configuration

; method to override OSCCON write protect

; B13:12=COSC1:0 B9:8=NOSC1:0
	MOV.B #0x01, W0

	MOV.B #0x78, W1

	MOV.B #0x9A, W2

	MOV.W #OSCCON, W3

	MOV.B W1, [W3+1]

	MOV.B W2, [W3+1]

	MOV.B W0, [W3+1]

; B7:6=POST1:0 B5=LOCK B3=CF B1=LPOSCEN B0=OSWEN
	MOV.B #0x40, W0

	MOV.B #0x46, W1

	MOV.B #0x57, W2

	MOV.B W1, [W3+0]

	MOV.B W2, [W3+0]

	MOV.B W0, [W3+0]

; Feature=A2D - A2D configuration
                    ; force all A2D ports to digital IO at first
	MOV #0xFFFF, W0
	MOV W0, ADPCFG

; Feature=IOPortB - IO Ports configuration

; B15:0=B15:0
	CLR PORTB                              ; enable
	MOV #0xFFFF, W0                        ; direction in=1
	MOV W0, TRISB

; Feature=IOPortC - IO Ports configuration

; B15:0=C15:0
	CLR PORTC                              ; enable
	MOV #0xFFFF, W0                        ; direction in=1
	MOV W0, TRISC

; Feature=IOPortD - IO Ports configuration

; B15:0=D15:0
	CLR PORTD                              ; enable
	MOV #0xFFFF, W0                        ; direction in=1
	MOV W0, TRISD

; Feature=IOPortE - IO Ports configuration

; B15:0=D15:0
	CLR PORTE                              ; enable
	MOV #0xFFFF, W0                        ; direction in=1
	MOV W0, TRISE

; Feature=IOPortF - IO Ports configuration

; B15:0=F15:0
	CLR PORTF                              ; enable
	MOV #0xFFFF, W0                        ; direction in=1
	MOV W0, TRISF

; Feature=CN1 - Input Change Notification configuration

; B15:0=CN15:0
	CLR CNEN1                              ; enable change notification
	CLR CNPU1                              ; enable pullup change notification

; B15:0=CN21:16 B7:0=CN7:0
	CLR CNEN2                              ; enable change notification
	CLR CNPU2                              ; enable pullup change notification

; Feature=Timer1 - Timers configuration
	CLR T1CON                              ; stop timer

; Feature=Timer2 - Timers configuration
	CLR T2CON                              ; stop timer

; Feature=Timer3 - Timers configuration
	CLR T3CON                              ; stop timer

; Feature=Timer4 - Timers configuration
	CLR T4CON                              ; stop timer

; Feature=Timer5 - Timers configuration
	CLR T5CON                              ; stop timer

; Feature=Timer1 - Timers configuration
	CLR TMR1                               ; timer register
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR1

; Feature=Timer3 - Timers configuration
	CLR TMR3                               ; timer register
	CLR TMR3HLD                            ; timer holding register for 32bit
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR3

; Feature=Timer2 - Timers configuration
	CLR TMR2                               ; timer register
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR2

; Feature=Timer5 - Timers configuration
	CLR TMR4                               ; timer register
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR4

; Feature=Timer4 - Timers configuration
	CLR TMR5                               ; timer register
	CLR TMR5HLD                            ; timer holding register for 32bit
	MOV #0xFFFF, W0                        ; period register
	MOV W0, PR5

; Feature=IC1 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC1CON

; Feature=IC2 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC2CON

; Feature=IC3 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC3CON

; Feature=IC4 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC4CON

; Feature=IC5 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC5CON

; Feature=IC6 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC6CON

; Feature=IC7 - Input Capture configuration

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0

; B13=ICSDL B7=ICTMR B6:5=ICI1:0 B4=ICOV B3=ICBNE B2:0=ICM2:0
	CLR IC7CON

; Feature=IC8 - Input Capture configuration
	CLR IC8CON

; Feature=OC1 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC1CON

; Feature=OC2 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC2CON

; Feature=OC3 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC3CON

; Feature=OC4 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC4CON

; Feature=OC5 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC5CON

; Feature=OC6 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC6CON

; Feature=OC7 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC7CON

; Feature=OC8 - Turn off OC1 thru OC8

; associated timers need to be turned off first
	CLR OC8CON

; Feature=OC1 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC1RS
	CLR OC1R
	CLR OC1CON

; Feature=OC2 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC2RS
	CLR OC2R
	CLR OC2CON

; Feature=OC3 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC3RS
	CLR OC3R
	CLR OC3CON

; Feature=OC4 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC4RS
	CLR OC4R
	CLR OC4CON

; Feature=OC5 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC5RS
	CLR OC5R
	CLR OC5CON

; Feature=OC6 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC6RS
	CLR OC6R
	CLR OC6CON

; Feature=OC7 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC7RS
	CLR OC7R
	CLR OC7CON

; Feature=OC8 - Output Compare configuration

; OCnRS:  output compare n secondary register

; OCnR:   output compare 1 main register

; OCnCON: B13=OCSIDL B4=OCFLT B3=OCTSEL B2:0=OCM2:0
	CLR OC8RS
	CLR OC8R
	CLR OC8CON

; Feature=SPI1 - SPI configuration

; SPInBUF:    SPI n buffer

; SPInSTAT:   B15=SPIEN B13=SPISIDL B6=SPITBF B5=SPIROV B0=SPIRBF

; SPInCON(H): B14=FRMEN B13=SPIFSD B11=DISSDO B10=MODE16 B9=SMP B8=CKE

; SPInCON(L): B7=SSEN B6=CKP B5=MSTEN B4:2=SPRE2:0 B1:0=PPRE1:0
	MOV SPI1BUF, W0
	CLR SPI1STAT
	CLR SPI1CON

; Feature=I2C - I2C configuration

; B7:0: receive register bits7:0
	MOV I2CRCV, W0

; B9:0: address register bits9:0
	CLR I2CADD

; B8:0: baud rate generator bits 8:0
	CLR I2CBRG

; B15=ACKSTAT B14=TRSTAT B10=BCL B9=GCSTAT B8=ADD10

; B7=IWCOL B6=I2COV B5=D_A B4=P B3=S B2=R_W B1=RBF B0=TBF
	CLR I2CSTAT

; B15=I2CEN B13=I2CSIDL B12=SCLREL B11=IPMIEN B10=A10M B9=DISSLW B8=SMEN

; B7=GCEN B6=STREN B5=ACKDT B4=ACKEN B3=RCEN B2=PEN B1=RSEN B0=SEN
	MOV #0x1000, W0
	MOV W0, I2CCON

; Feature=UART1 - UART 1 configuration
	CLR U1BRG                              ; UART1 baud rate generator

; B15=UTXISEL B11=UTXBRK B10=UTXEN B9=UTXBF B8=TRMT

; B7:6=URXISEL1:0 B5=ADDEN B4=RIDLE B3=PERR B2=FERR B1=OERR B0=URXDA
	MOV #0x8000, W0                        ; enabling UART flushes buffers
	MOV W0, U1MODE
	MOV #0x0110, W0
	MOV W0, U1STA

; B15=UARTEN B13=USIDL B10=ALTIO

; B7=WAKE B6=LPBACK B5=ABAUD B2:1=PDSEL1:0 B0=STSEL
	CLR U1MODE

; Feature=UART2 - UART 2 configuration
	CLR U2BRG                              ; UART2 baud rate generator

; B15=UTXISEL B11=UTXBRK B10=UTXEN B9=UTXBF B8=TRMT

; B7:6=URXISEL1:0 B5=ADDEN B4=RIDLE B3=PERR B2=FERR B1=OERR B0=URXDA
	MOV #0x8000, W0
	MOV W0, U2MODE
	MOV #0x0110, W0
	MOV W0, U2STA

; B15=UARTEN B13=USIDL B10=ALTIO

; B7=WAKE B6=LPBACK B5=ABAUD B2:1=PDSEL1:0 B0=STSEL
	CLR U2MODE

; Feature=CAN1 - CAN bus configuration

; Always abort pending TX before init.

	MOV C1CTRL, W0

	BSET W0, #12

	MOV W0, C1CTRL

	MOV #0x1000, W1

CAN1_TX_WAIT:		; wait for PIC to signal pending

	MOV C1CTRL, W0

	AND W1, W0, W0

	BRA NZ, CAN1_TX_WAIT

; Request CAN module go into config mode so

; we can update configuration registers.

	MOV C1CTRL, W0

	BCLR W0, #8

	BCLR W0, #9

	BCLR W0, #10

	BSET W0, #10

	MOV W0, C1CTRL

; Loop until current mode is 'config'.

	MOV #0x0080, W1

	MOV #0x00E0, W2

CAN1_CONFIG_WAIT:		; 

	MOV C1CTRL, W0

	AND W2, W0, W0

	SUB W1, W0, W0

	BRA NZ, CAN1_CONFIG_WAIT

; RXFnSID: B12:2=RXFnSID10:0 B0=EXIDEN

; RXFnEIDH: B11:0=EID17:6

; RXFnEIDL: B15:10=EID5:0
	CLR C1RXF0SID
	CLR C1RXF0EIDH
	CLR C1RXF0EIDL
	CLR C1RXF1SID
	CLR C1RXF0EIDH
	CLR C1RXF0EIDL
	CLR C1RXF2SID
	CLR C1RXF2EIDH
	CLR C1RXF2EIDL
	CLR C1RXF3SID
	CLR C1RXF3EIDH
	CLR C1RXF3EIDL
	CLR C1RXF4SID
	CLR C1RXF4EIDH
	CLR C1RXF4EIDL
	CLR C1RXF5SID
	CLR C1RXF5EIDH
	CLR C1RXF5EIDL

; RXMnSID: B12:2=RXFnSID10:0 B0=EXIDEN

; RXMnEIDH: B11:0=EID17:6

; RXMnEIDL: B15:10=EID5:0
	CLR C1RXM0SID
	CLR C1RXM0EIDH
	CLR C1RXM0EIDL
	CLR C1RXM1SID
	CLR C1RXM1EIDH
	CLR C1RXM1EIDL

; TXnSID: B15:11=TXnSID10:6 B7:2=SID5:0 B1=SRR B0=EXIDEN

; TXnEID: B15:12=EID17:14 B9:0=EID13:6

; TXnDLC: B15:10=EID5:0 B9=RTR B8:7=RB1:0 B6:3=DLC3:0

; TXnCON: B6=TXABT B5=TXLARB B4=TXERR B3=TXREQ B1:0=TXPRI1:0
	CLR C1TX2SID
	CLR C1TX2EID
	MOV #0x0180, W0
	MOV W0, C1TX2DLC
	CLR C1TX2CON
	CLR C1TX1SID
	CLR C1TX1EID
	MOV #0x0180, W0
	MOV W0, C1TX1DLC
	CLR C1TX1CON
	CLR C1TX0SID
	CLR C1TX0EID
	MOV #0x0180, W0
	MOV W0, C1TX0DLC
	CLR C1TX0CON

; RXnSID: B12:2=SID10:0 B1=SRR B0=EXIDEN

; RXnEID: B11:0=EID17:6

; RXnDLC: B15:10=EID5:0 B9=RTR B8=RB1 B4=RB0 B3:0=DLC3:0

; RXnCON: B7=RXFUL B3=RXRTRO B2=DBEN B1=JTOFF B0=FILHIT0
	CLR C1RX1SID
	CLR C1RX1EID
	MOV #0x0110, W0
	MOV W0, C1RX1DLC
	CLR C1RX1CON
	CLR C1RX0SID
	CLR C1RX0EID
	MOV #0x0110, W0
	MOV W0, C1RX0DLC
	CLR C1RX0CON

; B7:6=SJWS1:0 B5:0=BRP
	CLR C1CFG1

; B14=WAKFIL B10:8=SEG2PH

; B7=BTLMODE B6=SAM B5:3=SEG1PH B2:0=PRSEG
	CLR C1CFG2

; B15=CANCAP B13=CSIDLE B12=ABAT B11=CANCKS B10:8=REQOP2:0 B7:5=OPMODE2:0 B3:1=ICODE2:0
	MOV #0x0480, W0
	MOV W0, C1CTRL

; Flags: B15=RX0OVR B14=RX1OVR B13=TXBO B12=TXEP

; Flags: B11=RXEP B10=TXWAR B9=RXWAR B8=EWARN

; Flags IF, Enables IE: B7=IVRI B6=WAK B5=ERR B4=TX2 B3=TX1 B2=TX0 B1=RX1 B0=RX0
	CLR C1INTF                             ; clear all flags
	CLR C1INTE
	CLR C1EC                               ; clear tx and rx error registers

; request post-config operating mode for CAN module
	MOV #0x0480, W0                        ; send post config settings
	MOV W0, C1CTRL

	MOV C1CTRL, W1

	MOV #0x0700, W2

	AND W1, W2, W1

	LSR W1, #0x03, W1

	MOV #0x00E0, W2

CAN1_OPMODE_WAIT:		; 

	MOV C1CTRL, W0

	AND W2, W0, W0

	SUB W1, W0, W0

	BRA NZ, CAN1_OPMODE_WAIT

; Feature=PWM - Motor PWM configuration

; clears and preparation
	CLR PTCON                              ; disable during init
	CLR PTMR                               ; timer counter
	CLR PTPER                              ; count period
	CLR SEVTCMP                            ; special event condition

; B11:8=PTMOD3:0 B7:4=PENnH,n=0,3 B3:0=PENnL,n=0,3
	MOV #0x0F00, W0
	MOV W0, PWMCON1

; B11:8=SEVOPS3:0 B1=OSYNC B0=UDIS
	CLR PWMCON2

; dead time

; B15:14=DTBPS B13:8=DTBValue5:0 B7:6=DTAPS1:0 B5:0=DTAValue5:0
	CLR DTCON1

; B7=DTS4A B6=DTS4I B5=DTS3A B4=DTS3I B3=DTS2A B2=DTS2I B1=DTS1A B0=DTS1I
	CLR DTCON2

; faults

; B15=FAOV4H B14=FAOV4L B13=FAOV3H B12=FAOV3L

; B7=B11=FAOV2H B10=FAOV2L B9=FAOV1H B8=FAOV1L FLTAM B3:0=FAEN4:1
	CLR FLTACON

; B15=FBOV4H B14=FBOV4L B13=FBOV3H B12=FBOV3L

; B11=FBOV2H B10=FBOV2L B9=FBOV1H B8=FBOV1L B7=FLTBM B3:0=FBEN4:1
	CLR FLTBCON

; B15=POVD4H B14=POVD4L B13=POVD3H B12=POVD3L

; B11=POVD2H B10=POVD2L B9=POVD1H B8=POVD1L

; B15=POUT4H B14=POUT4L B13=POUT3H B12=POUT3L

; B11=POUT2H B10=POUT2L B9=POUT1H B8=POUT1L
	MOV #0xFF00, W0
	MOV W0, OVDCON

; duty cycle
	MOV #0xFFFF, W0                        ; duty cycle register 1
	MOV W0, PDC1
	MOV #0xFFFF, W0                        ; duty cycle register 2
	MOV W0, PDC2
	MOV #0xFFFF, W0                        ; duty cycle register 3
	MOV W0, PDC3
	MOV #0xFFFF, W0                        ; duty cycle register 4
	MOV W0, PDC4

; final enable

; B15=PTEN B13=PTSIDL B7:4=PTOPS3:0 B3:2=PRCKPS
	CLR PTCON

; Feature=QEI - QEI configuration
	CLR QEICON                             ; hard clear

; B10:9=IMV1:0 B8=CEID B7=QEOUT B6:4=QECK2:0
	CLR DFLTCON
	CLR POSCNT                             ; clear position counter
	MOV #0xFFFF, W0                        ; clear maximum count
	MOV W0, MAXCNT

; B15=CNTERR B13=QEISIDL B12=INDX B11=UPDN B10:8=QEIM2:0

; B7=SWPAB B6=PCDOUT B5=TQGATE

; B4:3=TQCLPS1:0 B2=POSRES B1=TQCS B0=UPDN_CNT
	CLR QEICON

; Feature=A2D - A2D configuration
                    ; Turn off A2D before setting registers
	CLR ADCON1

; B15:0=CSSL15:0
	CLR ADCSSL

; B15:14=CH123NB1:0 B13=CH123SB B12=CH0NB B11:8=CH0SB3:0

; B7:6=CH123NA1:0 B5=CH123SA B4=CH0NA B3:0=CH0SA3:0
	CLR ADCHS

; B15:0=PCFG15:0
	CLR ADPCFG

; B12:8=SAMC4:0 B7=ADRC B5:0=ADCS5:0
	CLR ADCON3

; B15:13=VCFG2:0 B12=OFFCAL B10=CSCNA B9:8=CHPS1:0

; B7=BUFS B5:2=SMPI B1=BUFM B0=ALTS
	CLR ADCON2

; B15=ADON B13=ADSIDL B12=ADSTBY B9:8=FORM

; B7:5=SSRC B3=SIMSAM B2=ASAM B1=SAMP B0=CONV
	CLR ADCON1

; Feature=required - Interrupt flags cleared and interrupt configuration

; interrupt priorities IP

; B14:12=T1 B10:8=OC1 B6:4=IC1 B2:0=INTO
	MOV #0x4444, W0
	MOV W0, IPC0

; B14:12=T3 B10:8=T2 B6:4=OC2 B2:0=IC2
	MOV #0x4444, W0
	MOV W0, IPC1

; B14:12=AD B10:8=U1TX B6:4=U1RX B2:0=SPI1
	MOV #0x4444, W0
	MOV W0, IPC2

; B14:12=CN B10:8= BCLB6:4=I2C B2:0=NVM
	MOV #0x4444, W0
	MOV W0, IPC3

; B14:12=OC3 B10:8=IC8 B6:4=IC7 B2:0=INT1
	MOV #0x4444, W0
	MOV W0, IPC4

; B14:12=INT2 B10:8=T5 B6:4=T4 B2:0=OC4
	MOV #0x4444, W0
	MOV W0, IPC5

; B14:12=C1 B10:8=SPI2 B6:4=U2TX B2:0=U2RX
	MOV #0x4444, W0
	MOV W0, IPC6

; B14:12=IC6 B10:8=IC5 B6:4=IC4 B2:0=IC3
	MOV #0x4444, W0
	MOV W0, IPC7

; B14:12=OC8 B10:8=OC7 B6:4=OC6 B2:0=OC5
	MOV #0x4444, W0
	MOV W0, IPC8

; B14:12=PWM B10:8=C2 B6:4=INT4 B2:0=INT3
	MOV #0x4444, W0
	MOV W0, IPC9

; B14:12=FLTA B10:8=LVD B6:4=DCI B2:0=QEI
	MOV #0x4044, W0
	MOV W0, IPC10

; B2:0=FLTBIP
	MOV #0x4444, W0
	MOV W0, IPC11

; external interrupt enables

; B15=NSTDIS B10=OVATE B9=OVBTE B8=COVTE

; B4=MATHERR B3=ADDRERR B2=STKERR B1=OSCFAIL
	CLR INTCON1

; B15=ALTIVT B4:0=INTnEP4:0
	CLR INTCON2

; Feature=Timer1 - Start timers

; Timers1: B15=TON B13=TSIDL B5=TGATE B5:4=TCKPS1:0 B2=TSYNC B1=TCS
	CLR T1CON

; Feature=Timer3 - Start timers

; Timers3,5:   B15=TON B13=TSIDL B5=TGATE B5:4=TCKPS1:0 B1=TCS
	CLR T3CON

; Feature=Timer2 - Start timers

; Timers2,4:   B15=TON B13=TSIDL B5=TGATE B5:4=TCKPS1:0 B3=T32 B1=TCS
	CLR T2CON

; Feature=Timer5 - Start timers

; Timers3,5:   B15=TON B13=TSIDL B5=TGATE B5:4=TCKPS1:0 B1=TCS
	CLR T5CON

; Feature=Timer4 - Start timers

; Timers2,4:   B15=TON B13=TSIDL B5=TGATE B5:4=TCKPS1:0 B3=T32 B1=TCS
	CLR T4CON

; Feature=CPU - CPU register configuration
	CLR SR
	CLR SR
	CLR W0
	CLR W1
	CLR W2

; Feature=Interrupts - enable interrupts

; feature interrupt enables IE

; B15=CN B14=BCL B13=I2C B12=NVM B11=AD B10=U1TX B9=U1RX B8=SPI1

; B7=T3 B6=T2 B5=OC2 B4=IC2 B3=T1 B2=OC1 B1=IC1 B0=INT0
	CLR IEC0

; B15:12=IC6:3 B11=C1 B10=SPI2 B9=U2TX B8=U2RX

; B7=INT2 B6=T5 B5=T4 B4=OC4 B3=OC3 B2=IC8 B1=IC7 B0=INT1
	CLR IEC1

; B12=FLTB B11=FLTA B10=LVD B9=DCI B8=QEI

; B7=PWM B6=C2 B5=INT4 B4=INT3 B3:0=OC8:5
	CLR IEC2

	return
